#include "stdafx.h"
#include "WaitTest.h"
#include "WaitTestDlg.h"
#include "WTimer.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

void MyCompletionRoutine(LPVOID /*pCompletionRoutineArgument*/, const FILETIME& /*ft*/)
{
  TRACE(_T("Completion routine called\n"));
}


CWaitTestDlg::CWaitTestDlg(CWnd* pParent)	: CDialog(CWaitTestDlg::IDD, pParent),
                                            m_hIcon(AfxGetApp()->LoadIcon(IDR_MAINFRAME))
{
}

void CWaitTestDlg::DoDataExchange(CDataExchange* pDX)
{
  //Let the base class do its thing
  CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CWaitTestDlg, CDialog)
  ON_WM_PAINT()
  ON_WM_QUERYDRAGICON()
  ON_BN_CLICKED(IDC_TEST1, &CWaitTestDlg::OnTest1)
END_MESSAGE_MAP()

BOOL CWaitTestDlg::OnInitDialog()
{
  //Let the base class do its thing
  CDialog::OnInitDialog();

  SetIcon(m_hIcon, TRUE);	 //Set big icon
  SetIcon(m_hIcon, FALSE); //Set small icon
  
  return TRUE; //return TRUE  unless you set the focus to a control
}

void CWaitTestDlg::OnPaint() 
{
  if (IsIconic())
  {
    CPaintDC dc(this); //device context for painting

    SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

    // enter icon in client rectangle
    int cxIcon = GetSystemMetrics(SM_CXICON);
    int cyIcon = GetSystemMetrics(SM_CYICON);
    CRect rect;
    GetClientRect(&rect);
    int x = (rect.Width() - cxIcon + 1) / 2;
    int y = (rect.Height() - cyIcon + 1) / 2;

    //Draw the icon
    dc.DrawIcon(x, y, m_hIcon);
  }
  else
    CDialog::OnPaint();
}

HCURSOR CWaitTestDlg::OnQueryDragIcon()
{
  return static_cast<HCURSOR>(m_hIcon);
}

void CWaitTestDlg::OnTest1() 
{
  //Display a cursor as this will hang the UI
  CWaitCursor wait;

  //Try out the timer class
  CWaitableTimer timer;	

  //Test out the create method
  VERIFY(timer.Create(FALSE, _T("PjTimer"), NULL));

  //Test out the other methods
  SYSTEMTIME st;
  GetSystemTime(&st);
  st.wSecond += 20;
  if (st.wSecond >= 50)
  {
    st.wSecond = static_cast<WORD>(st.wSecond % 60);
    st.wMinute++;
  }
  if (st.wMinute == 60)
  {
    st.wMinute = 0;
    st.wHour++;
  }
  if (st.wHour == 24)
  {
    st.wHour = 0;
    st.wDay++;
  }


  //Uncomment this chunk of code to test out the once off absolute method
  /*
  {
    VERIFY(timer.SetOnceOffAbsolute(st));

    //Use the following if you just want to wait until the timer becomes signalled
    //WaitForSingleObject(timer, INFINITE);

    //Use the following if you want to use the completion function support of CWaitableTimer
    SleepEx(INFINITE, TRUE);
  }
  */

  //Uncomment this chunk of code to test out the periodic absolute method
  /*
  {
    VERIFY(timer.SetPeriodicAbsolute(st, 1000));

    //Use the following if you just want to wait until the timer becomes signalled
    //WaitForSingleObject(timer, INFINITE);

    //Use the following if you want to use the completion function support of CWaitableTimer
    int i=0;
    while (i < 4)
    {
      SleepEx(INFINITE, TRUE);
      i++;
    }
  }
  */

  //Uncomment this chunk of code to test out the once off absolute method
  /*
  {
    VERIFY(timer.SetOnceOffRelative(5000));

    //Use the following if you just want to wait until the timer becomes signalled
    //WaitForSingleObject(timer, INFINITE);

    //Use the following if you want to use the completion function support of CWaitableTimer
    SleepEx(INFINITE, TRUE);
  }
  */

  //Uncomment this chunk of code to test out the periodic relative method
  /*
  {
    VERIFY(timer.SetPeriodicRelative(5000, 1000));

    //Use the following if you just want to wait until the timer becomes signalled
    //WaitForSingleObject(timer, INFINITE);

    //Use the following if you want to use the completion function support of CWaitableTimer
    int i=0;
    while (i < 4)
    {
      SleepEx(INFINITE, TRUE);
      i++;
    }
  }
  */

  //Uncomment this chunk of code to test out the CreateWaitableTimerEx / SetWaitableTimerEx support
  /*
  {
    CWaitableTimer timer2;
    VERIFY(timer2.Create(0, TIMER_MODIFY_STATE));

    REASON_CONTEXT rc;
    rc.Version = POWER_REQUEST_CONTEXT_VERSION;
    rc.Flags = POWER_REQUEST_CONTEXT_SIMPLE_STRING;
    rc.Reason.SimpleReasonString = L"A request from a waitable timer";

    VERIFY(timer2.SetOnceOffAbsolute(st, NULL, NULL, &rc, 1000));
    VERIFY(timer2.SetPeriodicAbsolute(st, 1000, NULL, NULL, &rc, 1000));
    VERIFY(timer2.SetOnceOffRelative(5000, NULL, NULL, &rc, 1000));
    VERIFY(timer2.SetPeriodicRelative(5000, 1000, NULL, NULL, &rc, 1000));
    
    //Use the following if you just want to wait until the timer becomes signalled
    WaitForSingleObject(timer2, INFINITE);

    //Use the following if you want to use the completion function support of CWaitableTimer
    //SleepEx(INFINITE, TRUE);
  }
  */
}
